Index: branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/HiveEngine.cs
===================================================================
--- branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/HiveEngine.cs	(revision 5281)
+++ branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/HiveEngine.cs	(revision 5282)
@@ -33,4 +33,11 @@
     public string ResourceIds { get; set; }
 
+    [Storable]
+    private int priority;
+    public int Priority {
+      get { return priority; }
+      set { priority = value; }
+    }
+    
     #region constructors and cloning
     public HiveEngine() {
@@ -43,4 +50,5 @@
       this.ResourceIds = original.ResourceIds;
       this.currentOperator = cloner.Clone(original.currentOperator);
+      this.priority = original.priority;
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -292,4 +300,5 @@
       serializedJob.JobInfo.CoresNeeded = 1;
       serializedJob.JobInfo.PluginsNeeded = pluginsNeeded;
+      serializedJob.JobInfo.Priority = priority;
       ResponseObject<JobDto> response = null;
       maxConcurrentConnections.WaitOne();
Index: branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.Designer.cs	(revision 5281)
+++ branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.Designer.cs	(revision 5282)
@@ -26,10 +26,12 @@
       this.resourceIdsLabel = new System.Windows.Forms.Label();
       this.resourceIdsTextBox = new System.Windows.Forms.TextBox();
+      this.priorityLabel = new System.Windows.Forms.Label();
+      this.priorityTextBox = new System.Windows.Forms.TextBox();
       this.SuspendLayout();
       // 
       // logView
       // 
-      this.logView.Location = new System.Drawing.Point(0, 49);
-      this.logView.Size = new System.Drawing.Size(430, 302);
+      this.logView.Location = new System.Drawing.Point(0, 81);
+      this.logView.Size = new System.Drawing.Size(430, 270);
       // 
       // resourceIdsLabel
@@ -51,4 +53,21 @@
       this.resourceIdsTextBox.TextChanged += new System.EventHandler(this.resourceIdsTextBox_TextChanged);
       // 
+      // priorityLabel
+      // 
+      this.priorityLabel.AutoSize = true;
+      this.priorityLabel.Location = new System.Drawing.Point(3, 49);
+      this.priorityLabel.Name = "priorityLabel";
+      this.priorityLabel.Size = new System.Drawing.Size(41, 13);
+      this.priorityLabel.TabIndex = 5;
+      this.priorityLabel.Text = "Priority:";
+      // 
+      // priorityTextBox
+      // 
+      this.priorityTextBox.Location = new System.Drawing.Point(73, 46);
+      this.priorityTextBox.Name = "priorityTextBox";
+      this.priorityTextBox.Size = new System.Drawing.Size(357, 20);
+      this.priorityTextBox.TabIndex = 6;
+      this.priorityTextBox.TextChanged += new System.EventHandler(this.priorityTextBox_TextChanged);
+      // 
       // HiveEngineView
       // 
@@ -56,7 +75,11 @@
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.Controls.Add(this.resourceIdsTextBox);
+      this.Controls.Add(this.priorityTextBox);
       this.Controls.Add(this.resourceIdsLabel);
+      this.Controls.Add(this.priorityLabel);
       this.Name = "HiveEngineView";
+      this.Controls.SetChildIndex(this.priorityLabel, 0);
       this.Controls.SetChildIndex(this.resourceIdsLabel, 0);
+      this.Controls.SetChildIndex(this.priorityTextBox, 0);
       this.Controls.SetChildIndex(this.resourceIdsTextBox, 0);
       this.Controls.SetChildIndex(this.logView, 0);
@@ -72,4 +95,6 @@
     private System.Windows.Forms.Label resourceIdsLabel;
     private System.Windows.Forms.TextBox resourceIdsTextBox;
+    private System.Windows.Forms.Label priorityLabel;
+    private System.Windows.Forms.TextBox priorityTextBox;
   }
 }
Index: branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.cs	(revision 5281)
+++ branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.cs	(revision 5282)
@@ -24,5 +24,4 @@
 
     protected override void DeregisterContentEvents() {
-      // TODO: Deregister your event handlers here
       base.DeregisterContentEvents();
     }
@@ -30,9 +29,8 @@
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
-      // TODO: Register your event handlers here
     }
 
     #region Event Handlers (Content)
-    // TODO: Put event handlers of the content here
+    // Put event handlers of the content here
     #endregion
 
@@ -40,7 +38,9 @@
       base.OnContentChanged();
       if (Content == null) {
-        // TODO: Add code when content has been changed and is null
+        resourceIdsTextBox.Text = string.Empty;
+        priorityTextBox.Text = string.Empty;
       } else {
-        // TODO: Add code when content has been changed and is not null
+        resourceIdsTextBox.Text = Content.ResourceIds;
+        priorityTextBox.Text = Content.Priority.ToString();
       }
     }
@@ -52,6 +52,8 @@
       if (Content != null) {
         resourceIdsTextBox.ReadOnly = this.ReadOnly;
+        priorityTextBox.ReadOnly = this.ReadOnly;
       } else {
         resourceIdsTextBox.ReadOnly = false;
+        priorityTextBox.ReadOnly = false;
       }
     }
@@ -62,4 +64,8 @@
     }
     #endregion
+
+    private void priorityTextBox_TextChanged(object sender, EventArgs e) {
+      Content.Priority = int.Parse(priorityTextBox.Text);
+    }
   }
 }
Index: branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.resx
===================================================================
--- branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.resx	(revision 5281)
+++ branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.HiveEngine/3.3/Views/HiveEngineView.resx	(revision 5282)
@@ -113,8 +113,8 @@
   </resheader>
   <resheader name="reader">
-    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
   </resheader>
   <resheader name="writer">
-    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
   </resheader>
 </root>