Index: branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/AndFilter.cs
===================================================================
--- branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/AndFilter.cs	(revision 5286)
+++ branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/AndFilter.cs	(revision 5286)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.Services.OKB.DataTransfer {
+  [DataContract]
+  public class AndFilter : CombinedFilter {
+    public AndFilter(string filterTypeName, string label) {
+      FilterTypeName = filterTypeName;
+      Label = label;
+      Filters = Enumerable.Empty<Filter>();
+    }
+  }
+}
Index: branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/CombinedFilter.cs
===================================================================
--- branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/CombinedFilter.cs	(revision 5286)
+++ branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/CombinedFilter.cs	(revision 5286)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.DataTransfer {
+  [DataContract]
+  public abstract class CombinedFilter : Filter {
+    [DataMember]
+    public IEnumerable<Filter> Filters { get; set; }
+  }
+}
Index: branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/Filter.cs
===================================================================
--- branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/Filter.cs	(revision 5269)
+++ branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/Filter.cs	(revision 5286)
@@ -28,4 +28,5 @@
   [KnownType(typeof(OrdinalComparisonLongFilter))]
   [KnownType(typeof(SetComparisonStringFilter))]
+  [KnownType(typeof(SetComparisonStringAvailableValuesFilter))]
   [KnownType(typeof(NameEqualityComparisonBoolFilter))]
   [KnownType(typeof(NameEqualityComparisonByteArrayFilter))]
@@ -33,4 +34,7 @@
   [KnownType(typeof(NameOrdinalComparisonLongFilter))]
   [KnownType(typeof(NameSetComparisonStringFilter))]
+  [KnownType(typeof(NameSetComparisonStringAvailableValuesFilter))]
+  [KnownType(typeof(AndFilter))]
+  [KnownType(typeof(OrFilter))]
   public abstract class Filter {
     [DataMember]
Index: branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/NameSetComparisonStringAvailableValuesFilter.cs
===================================================================
--- branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/NameSetComparisonStringAvailableValuesFilter.cs	(revision 5286)
+++ branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/NameSetComparisonStringAvailableValuesFilter.cs	(revision 5286)
@@ -0,0 +1,36 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.DataTransfer {
+  [DataContract]
+  public class NameSetComparisonStringAvailableValuesFilter : NameSetComparisonStringFilter {
+    [DataMember]
+    public IEnumerable<string> AvailableValues { get; protected set; }
+
+    public NameSetComparisonStringAvailableValuesFilter(string filterTypeName, string label, string name, IEnumerable<string> availableValues)
+      : base(filterTypeName, label, name) {
+      AvailableValues = availableValues;
+    }
+  }
+}
Index: branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/OrFilter.cs
===================================================================
--- branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/OrFilter.cs	(revision 5286)
+++ branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/OrFilter.cs	(revision 5286)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Runtime.Serialization;
+using System.Linq;
+
+namespace HeuristicLab.Services.OKB.DataTransfer {
+  [DataContract]
+  public class OrFilter : CombinedFilter {
+    public OrFilter(string filterTypeName, string label) {
+      FilterTypeName = filterTypeName;
+      Label = label;
+      Filters = Enumerable.Empty<Filter>();
+    }
+  }
+}
Index: branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/SetComparisonStringAvailableValuesFilter.cs
===================================================================
--- branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/SetComparisonStringAvailableValuesFilter.cs	(revision 5286)
+++ branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/Filters/SetComparisonStringAvailableValuesFilter.cs	(revision 5286)
@@ -0,0 +1,36 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Services.OKB.DataTransfer {
+  [DataContract]
+  public class SetComparisonStringAvailableValuesFilter : SetComparisonStringFilter {
+    [DataMember]
+    public IEnumerable<string> AvailableValues { get; protected set; }
+
+    public SetComparisonStringAvailableValuesFilter(string filterTypeName, string label, IEnumerable<string> availableValues)
+      : base(filterTypeName, label) {
+      AvailableValues = availableValues;
+    }
+  }
+}
Index: branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/HeuristicLab.Services.OKB.DataTransfer-3.3.csproj
===================================================================
--- branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/HeuristicLab.Services.OKB.DataTransfer-3.3.csproj	(revision 5269)
+++ branches/OKB/HeuristicLab.Services.OKB.DataTransfer/3.3/HeuristicLab.Services.OKB.DataTransfer-3.3.csproj	(revision 5286)
@@ -58,4 +58,9 @@
     <Compile Include="AlgorithmParameterIntValue.cs" />
     <Compile Include="AlgorithmParameterStringValue.cs" />
+    <Compile Include="Filters\CombinedFilter.cs" />
+    <Compile Include="Filters\AndFilter.cs" />
+    <Compile Include="Filters\NameSetComparisonStringAvailableValuesFilter.cs" />
+    <Compile Include="Filters\SetComparisonStringAvailableValuesFilter.cs" />
+    <Compile Include="Filters\OrFilter.cs" />
     <Compile Include="Filters\OrdinalComparisonFilter.cs" />
     <Compile Include="Filters\SetComparisonFilter.cs" />