Index: trunk/sources/HeuristicLab.Data/3.3/BoolValue.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/BoolValue.cs	(revision 5163)
+++ trunk/sources/HeuristicLab.Data/3.3/BoolValue.cs	(revision 5287)
@@ -32,5 +32,5 @@
   public class BoolValue : ValueTypeValue<bool>, IComparable, IStringConvertibleValue {
     public override Image ItemImage {
-      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Field; }
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Field; }
     }
 
Index: trunk/sources/HeuristicLab.Data/3.3/Comparison.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/Comparison.cs	(revision 5163)
+++ trunk/sources/HeuristicLab.Data/3.3/Comparison.cs	(revision 5287)
@@ -31,5 +31,5 @@
   public class Comparison : ValueTypeValue<ComparisonType>, IComparable {
     public override Image ItemImage {
-      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Enum; }
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Enum; }
     }
 
Index: trunk/sources/HeuristicLab.Data/3.3/DoubleValue.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/DoubleValue.cs	(revision 5163)
+++ trunk/sources/HeuristicLab.Data/3.3/DoubleValue.cs	(revision 5287)
@@ -32,5 +32,5 @@
   public class DoubleValue : ValueTypeValue<double>, IComparable, IStringConvertibleValue {
     public override Image ItemImage {
-      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Field; }
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Field; }
     }
 
Index: trunk/sources/HeuristicLab.Data/3.3/IntValue.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/IntValue.cs	(revision 5163)
+++ trunk/sources/HeuristicLab.Data/3.3/IntValue.cs	(revision 5287)
@@ -32,5 +32,5 @@
   public class IntValue : ValueTypeValue<int>, IComparable, IStringConvertibleValue {
     public override Image ItemImage {
-      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Field; }
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Field; }
     }
 
Index: trunk/sources/HeuristicLab.Data/3.3/StringArray.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/StringArray.cs	(revision 5163)
+++ trunk/sources/HeuristicLab.Data/3.3/StringArray.cs	(revision 5287)
@@ -35,5 +35,5 @@
   public class StringArray : Item, IEnumerable<string>, IStringConvertibleArray {
     public override Image ItemImage {
-      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Class; }
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
     }
 
Index: trunk/sources/HeuristicLab.Data/3.3/StringMatrix.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/StringMatrix.cs	(revision 5163)
+++ trunk/sources/HeuristicLab.Data/3.3/StringMatrix.cs	(revision 5287)
@@ -35,5 +35,5 @@
   public class StringMatrix : Item, IEnumerable<string>, IStringConvertibleMatrix {
     public override Image ItemImage {
-      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Class; }
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
     }
 
Index: trunk/sources/HeuristicLab.Data/3.3/StringValue.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/StringValue.cs	(revision 5163)
+++ trunk/sources/HeuristicLab.Data/3.3/StringValue.cs	(revision 5287)
@@ -31,5 +31,5 @@
   public class StringValue : Item, IComparable, IStringConvertibleValue {
     public override Image ItemImage {
-      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Field; }
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Field; }
     }
 
Index: trunk/sources/HeuristicLab.Data/3.3/ValueTypeArray.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/ValueTypeArray.cs	(revision 5163)
+++ trunk/sources/HeuristicLab.Data/3.3/ValueTypeArray.cs	(revision 5287)
@@ -35,5 +35,5 @@
   public abstract class ValueTypeArray<T> : Item, IEnumerable<T> where T : struct {
     public override Image ItemImage {
-      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Class; }
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
     }
 
Index: trunk/sources/HeuristicLab.Data/3.3/ValueTypeMatrix.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/ValueTypeMatrix.cs	(revision 5163)
+++ trunk/sources/HeuristicLab.Data/3.3/ValueTypeMatrix.cs	(revision 5287)
@@ -35,5 +35,5 @@
   public abstract class ValueTypeMatrix<T> : Item, IEnumerable<T> where T : struct {
     public override Image ItemImage {
-      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Class; }
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
     }
 
Index: trunk/sources/HeuristicLab.Data/3.3/ValueTypeValue.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/ValueTypeValue.cs	(revision 5163)
+++ trunk/sources/HeuristicLab.Data/3.3/ValueTypeValue.cs	(revision 5287)
@@ -31,5 +31,5 @@
   public abstract class ValueTypeValue<T> : Item where T : struct {
     public override Image ItemImage {
-      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.ValueType; }
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.ValueType; }
     }
 