Index: branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/QueryView.Designer.cs
===================================================================
--- branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/QueryView.Designer.cs	(revision 5289)
+++ branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/QueryView.Designer.cs	(revision 5295)
@@ -46,6 +46,5 @@
     private void InitializeComponent() {
       this.components = new System.ComponentModel.Container();
-      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(QueryView));
-      this.refreshButton = new System.Windows.Forms.Button();
+      this.refreshResultsButton = new System.Windows.Forms.Button();
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
       this.showRunsButton = new System.Windows.Forms.Button();
@@ -54,5 +53,6 @@
       this.filtersGroupBox = new System.Windows.Forms.GroupBox();
       this.resultsGroupBox = new System.Windows.Forms.GroupBox();
-      this.andFilterView = new HeuristicLab.Clients.OKB.AndFilterView();
+      this.nrOfRunsButton = new System.Windows.Forms.Button();
+      this.filterPanel = new System.Windows.Forms.Panel();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
@@ -63,14 +63,14 @@
       this.SuspendLayout();
       // 
-      // refreshButton
+      // refreshResultsButton
       // 
-      this.refreshButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Refresh;
-      this.refreshButton.Location = new System.Drawing.Point(6, 19);
-      this.refreshButton.Name = "refreshButton";
-      this.refreshButton.Size = new System.Drawing.Size(24, 24);
-      this.refreshButton.TabIndex = 0;
-      this.toolTip.SetToolTip(this.refreshButton, "Refresh Data");
-      this.refreshButton.UseVisualStyleBackColor = true;
-      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
+      this.refreshResultsButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Refresh;
+      this.refreshResultsButton.Location = new System.Drawing.Point(6, 19);
+      this.refreshResultsButton.Name = "refreshResultsButton";
+      this.refreshResultsButton.Size = new System.Drawing.Size(24, 24);
+      this.refreshResultsButton.TabIndex = 0;
+      this.toolTip.SetToolTip(this.refreshResultsButton, "Refresh Results");
+      this.refreshResultsButton.UseVisualStyleBackColor = true;
+      this.refreshResultsButton.Click += new System.EventHandler(this.refreshResultsButton_Click);
       // 
       // showRunsButton
@@ -122,5 +122,5 @@
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.filtersGroupBox.Controls.Add(this.andFilterView);
+      this.filtersGroupBox.Controls.Add(this.filterPanel);
       this.filtersGroupBox.Location = new System.Drawing.Point(0, 0);
       this.filtersGroupBox.Name = "filtersGroupBox";
@@ -135,5 +135,6 @@
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.resultsGroupBox.Controls.Add(this.refreshButton);
+      this.resultsGroupBox.Controls.Add(this.nrOfRunsButton);
+      this.resultsGroupBox.Controls.Add(this.refreshResultsButton);
       this.resultsGroupBox.Controls.Add(this.runCollectionView);
       this.resultsGroupBox.Controls.Add(this.showRunsButton);
@@ -145,16 +146,23 @@
       this.resultsGroupBox.Text = "Results";
       // 
-      // andFilterView
+      // nrOfRunsButton
       // 
-      this.andFilterView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+      this.nrOfRunsButton.Location = new System.Drawing.Point(117, 19);
+      this.nrOfRunsButton.Name = "nrOfRunsButton";
+      this.nrOfRunsButton.Size = new System.Drawing.Size(75, 23);
+      this.nrOfRunsButton.TabIndex = 3;
+      this.nrOfRunsButton.Text = "No. of Runs";
+      this.nrOfRunsButton.UseVisualStyleBackColor = true;
+      this.nrOfRunsButton.Click += new System.EventHandler(this.nrOfRunsButton_Click);
+      // 
+      // filterPanel
+      // 
+      this.filterPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.andFilterView.Caption = "AndFilter View";
-      this.andFilterView.Content = null;
-      this.andFilterView.Location = new System.Drawing.Point(6, 19);
-      this.andFilterView.Name = "andFilterView";
-      this.andFilterView.ReadOnly = false;
-      this.andFilterView.Size = new System.Drawing.Size(722, 189);
-      this.andFilterView.TabIndex = 0;
+      this.filterPanel.Location = new System.Drawing.Point(6, 19);
+      this.filterPanel.Name = "filterPanel";
+      this.filterPanel.Size = new System.Drawing.Size(722, 189);
+      this.filterPanel.TabIndex = 0;
       // 
       // QueryView
@@ -177,5 +185,5 @@
     #endregion
 
-    private System.Windows.Forms.Button refreshButton;
+    private System.Windows.Forms.Button refreshResultsButton;
     private System.Windows.Forms.ToolTip toolTip;
     private RunCollectionView runCollectionView;
@@ -184,5 +192,6 @@
     private System.Windows.Forms.GroupBox filtersGroupBox;
     private System.Windows.Forms.GroupBox resultsGroupBox;
-    private AndFilterView andFilterView;
+    private System.Windows.Forms.Button nrOfRunsButton;
+    private System.Windows.Forms.Panel filterPanel;
 
   }