Index: branches/OKB (trunk integration)/MergeConfigs.cmd
===================================================================
--- branches/OKB (trunk integration)/MergeConfigs.cmd	(revision 5296)
+++ 	(revision )
@@ -1,2 +1,0 @@
-ConfigMerger "%SolutionDir%\ServiceClient.config" "C:\Program Files\HeuristicLab 3.0\HeuristicLab.exe.config"
-
Index: branches/OKB (trunk integration)/ServiceClient.config
===================================================================
--- branches/OKB (trunk integration)/ServiceClient.config	(revision 5296)
+++ 	(revision )
@@ -1,121 +1,0 @@
-<?xml version="1.0" encoding="utf-8" ?>
-<configuration>
-  <system.serviceModel>
-    <bindings>
-      <netTcpBinding>
-        <binding name="NetTcpBinding_IAdminService" closeTimeout="00:01:00"
-            openTimeout="00:01:00" receiveTimeout="00:10:00" sendTimeout="00:01:00"
-            transactionFlow="false" transferMode="Buffered" transactionProtocol="OleTransactions"
-            hostNameComparisonMode="StrongWildcard" listenBacklog="10"
-            maxBufferPoolSize="524288" maxBufferSize="65536" maxConnections="10"
-            maxReceivedMessageSize="65536">
-          <readerQuotas maxDepth="32" maxStringContentLength="8192" maxArrayLength="16384"
-              maxBytesPerRead="4096" maxNameTableCharCount="16384" />
-          <reliableSession ordered="true" inactivityTimeout="00:10:00"
-              enabled="false" />
-          <security mode="Message">
-            <transport clientCredentialType="Windows" protectionLevel="EncryptAndSign" />
-            <message clientCredentialType="UserName" algorithmSuite="Default" />
-          </security>
-        </binding>
-        <binding name="NetTcpBinding_IDataService" closeTimeout="00:01:00"
-            openTimeout="00:01:00" receiveTimeout="00:10:00" sendTimeout="00:01:00"
-            transactionFlow="false" transferMode="Buffered" transactionProtocol="OleTransactions"
-            hostNameComparisonMode="StrongWildcard" listenBacklog="10"
-            maxBufferPoolSize="524288" maxBufferSize="65536" maxConnections="10"
-            maxReceivedMessageSize="65536">
-          <readerQuotas maxDepth="32" maxStringContentLength="8192" maxArrayLength="16384"
-              maxBytesPerRead="4096" maxNameTableCharCount="16384" />
-          <reliableSession ordered="true" inactivityTimeout="00:10:00"
-              enabled="false" />
-          <security mode="Message">
-            <transport clientCredentialType="Windows" protectionLevel="EncryptAndSign" />
-            <message clientCredentialType="UserName" algorithmSuite="Default" />
-          </security>
-        </binding>
-        <binding name="NetTcpBinding_ITableService" closeTimeout="00:01:00"
-            openTimeout="00:01:00" receiveTimeout="00:10:00" sendTimeout="00:01:00"
-            transactionFlow="false" transferMode="Buffered" transactionProtocol="OleTransactions"
-            hostNameComparisonMode="StrongWildcard" listenBacklog="10"
-            maxBufferPoolSize="524288" maxBufferSize="65536" maxConnections="10"
-            maxReceivedMessageSize="65536">
-          <readerQuotas maxDepth="32" maxStringContentLength="8192" maxArrayLength="16384"
-              maxBytesPerRead="4096" maxNameTableCharCount="16384" />
-          <reliableSession ordered="true" inactivityTimeout="00:10:00"
-              enabled="false" />
-          <security mode="Message">
-            <transport clientCredentialType="Windows" protectionLevel="EncryptAndSign" />
-            <message clientCredentialType="UserName" algorithmSuite="Default" />
-          </security>
-        </binding>
-        <binding name="NetTcpBinding_IRunnerService" closeTimeout="00:01:00"
-            openTimeout="00:01:00" receiveTimeout="00:10:00" sendTimeout="00:01:00"
-            transactionFlow="false" transferMode="Buffered" transactionProtocol="OleTransactions"
-            hostNameComparisonMode="StrongWildcard" listenBacklog="10"
-            maxBufferPoolSize="524288" maxBufferSize="65536" maxConnections="10"
-            maxReceivedMessageSize="65536">
-          <readerQuotas maxDepth="32" maxStringContentLength="8192" maxArrayLength="16384"
-              maxBytesPerRead="4096" maxNameTableCharCount="16384" />
-          <reliableSession ordered="true" inactivityTimeout="00:10:00"
-              enabled="false" />
-          <security mode="Message">
-            <transport clientCredentialType="Windows" protectionLevel="EncryptAndSign" />
-            <message clientCredentialType="UserName" algorithmSuite="Default" />
-          </security>
-        </binding>
-        <binding name="NetTcpBinding_IQueryService" closeTimeout="00:01:00"
-            openTimeout="00:01:00" receiveTimeout="00:10:00" sendTimeout="00:01:00"
-            transactionFlow="false" transferMode="Buffered" transactionProtocol="OleTransactions"
-            hostNameComparisonMode="StrongWildcard" listenBacklog="10"
-            maxBufferPoolSize="524288" maxBufferSize="65536" maxConnections="10"
-            maxReceivedMessageSize="65536">
-          <readerQuotas maxDepth="32" maxStringContentLength="8192" maxArrayLength="16384"
-              maxBytesPerRead="4096" maxNameTableCharCount="16384" />
-          <reliableSession ordered="true" inactivityTimeout="00:10:00"
-              enabled="false" />
-          <security mode="Message">
-            <transport clientCredentialType="Windows" protectionLevel="EncryptAndSign" />
-            <message clientCredentialType="UserName" algorithmSuite="Default" />
-          </security>
-        </binding>
-      </netTcpBinding>
-    </bindings>
-    <client>
-      <endpoint address="net.tcp://localhost:8733/OKB-3.3/AdminService"
-          binding="netTcpBinding" bindingConfiguration="NetTcpBinding_IAdminService"
-          contract="OKBAdmin.IAdminService" name="NetTcpBinding_IAdminService">
-        <identity>
-          <certificate encodedValue="AwAAAAEAAAAUAAAAD/AlkYJw/OUhl6D/9w8mjJBh39kgAAAAAQAAAPIBAAAwggHuMIIBW6ADAgECAhAdEzTisaf2sEZxrqYZfYtCMAkGBSsOAwIdBQAwFDESMBAGA1UEAxMJbG9jYWxob3N0MB4XDTEwMDgyMDIyMzIwOFoXDTM5MTIzMTIzNTk1OVowFDESMBAGA1UEAxMJbG9jYWxob3N0MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDPkfCSLRX8/4F+Z4ys43yZ4MMzjB44cMakPz4Nri+mEB5n2z/0GFatCYzkI2f/nniWqVrBYjHkjsZy2EZioHu4wa99c1XEGJnFNDuNn6ESkfEyhyF4+OqKGnpK9HNrw7OWMuqn2oOh0iFd9fl6FTAm+Y0p3LP+38BuYzpCniqqdwIDAQABo0kwRzBFBgNVHQEEPjA8gBDvi8Rgio9v+mr58TiAvqF5oRYwFDESMBAGA1UEAxMJbG9jYWxob3N0ghAdEzTisaf2sEZxrqYZfYtCMAkGBSsOAwIdBQADgYEANdGlvHKeUptfNu9I0wgA5qjmVB+JDldOAkrfM0R+4IcVQ06y5K7P07uxQAV7+rhnDLgLyFJunUHgzbfjsjFy7vjwtoieXA5j0AYlm4AHR7dHt4HVgkIMYt8XOCqMw5jjFX91xJ89tC7mM9zYR48N9T5QSeMGo+f+JzybeLWxnNs=" />
-        </identity>
-      </endpoint>
-      <endpoint address="net.tcp://localhost:8733/OKB-3.3/DataService"
-          binding="netTcpBinding" bindingConfiguration="NetTcpBinding_IDataService"
-          contract="OKBData.IDataService" name="NetTcpBinding_IDataService">
-        <identity>
-          <certificate encodedValue="AwAAAAEAAAAUAAAAD/AlkYJw/OUhl6D/9w8mjJBh39kgAAAAAQAAAPIBAAAwggHuMIIBW6ADAgECAhAdEzTisaf2sEZxrqYZfYtCMAkGBSsOAwIdBQAwFDESMBAGA1UEAxMJbG9jYWxob3N0MB4XDTEwMDgyMDIyMzIwOFoXDTM5MTIzMTIzNTk1OVowFDESMBAGA1UEAxMJbG9jYWxob3N0MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDPkfCSLRX8/4F+Z4ys43yZ4MMzjB44cMakPz4Nri+mEB5n2z/0GFatCYzkI2f/nniWqVrBYjHkjsZy2EZioHu4wa99c1XEGJnFNDuNn6ESkfEyhyF4+OqKGnpK9HNrw7OWMuqn2oOh0iFd9fl6FTAm+Y0p3LP+38BuYzpCniqqdwIDAQABo0kwRzBFBgNVHQEEPjA8gBDvi8Rgio9v+mr58TiAvqF5oRYwFDESMBAGA1UEAxMJbG9jYWxob3N0ghAdEzTisaf2sEZxrqYZfYtCMAkGBSsOAwIdBQADgYEANdGlvHKeUptfNu9I0wgA5qjmVB+JDldOAkrfM0R+4IcVQ06y5K7P07uxQAV7+rhnDLgLyFJunUHgzbfjsjFy7vjwtoieXA5j0AYlm4AHR7dHt4HVgkIMYt8XOCqMw5jjFX91xJ89tC7mM9zYR48N9T5QSeMGo+f+JzybeLWxnNs=" />
-        </identity>
-      </endpoint>
-      <endpoint address="net.tcp://localhost:8733/OKB-3.3/TableService"
-          binding="netTcpBinding" bindingConfiguration="NetTcpBinding_ITableService"
-          contract="OKBTables.ITableService" name="NetTcpBinding_ITableService">
-        <identity>
-          <certificate encodedValue="AwAAAAEAAAAUAAAAD/AlkYJw/OUhl6D/9w8mjJBh39kgAAAAAQAAAPIBAAAwggHuMIIBW6ADAgECAhAdEzTisaf2sEZxrqYZfYtCMAkGBSsOAwIdBQAwFDESMBAGA1UEAxMJbG9jYWxob3N0MB4XDTEwMDgyMDIyMzIwOFoXDTM5MTIzMTIzNTk1OVowFDESMBAGA1UEAxMJbG9jYWxob3N0MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDPkfCSLRX8/4F+Z4ys43yZ4MMzjB44cMakPz4Nri+mEB5n2z/0GFatCYzkI2f/nniWqVrBYjHkjsZy2EZioHu4wa99c1XEGJnFNDuNn6ESkfEyhyF4+OqKGnpK9HNrw7OWMuqn2oOh0iFd9fl6FTAm+Y0p3LP+38BuYzpCniqqdwIDAQABo0kwRzBFBgNVHQEEPjA8gBDvi8Rgio9v+mr58TiAvqF5oRYwFDESMBAGA1UEAxMJbG9jYWxob3N0ghAdEzTisaf2sEZxrqYZfYtCMAkGBSsOAwIdBQADgYEANdGlvHKeUptfNu9I0wgA5qjmVB+JDldOAkrfM0R+4IcVQ06y5K7P07uxQAV7+rhnDLgLyFJunUHgzbfjsjFy7vjwtoieXA5j0AYlm4AHR7dHt4HVgkIMYt8XOCqMw5jjFX91xJ89tC7mM9zYR48N9T5QSeMGo+f+JzybeLWxnNs=" />
-        </identity>
-      </endpoint>
-      <endpoint address="net.tcp://localhost:8733/OKB-3.3/RunnerService"
-          binding="netTcpBinding" bindingConfiguration="NetTcpBinding_IRunnerService"
-          contract="OKBRunner.IRunnerService" name="NetTcpBinding_IRunnerService">
-        <identity>
-          <certificate encodedValue="AwAAAAEAAAAUAAAAD/AlkYJw/OUhl6D/9w8mjJBh39kgAAAAAQAAAPIBAAAwggHuMIIBW6ADAgECAhAdEzTisaf2sEZxrqYZfYtCMAkGBSsOAwIdBQAwFDESMBAGA1UEAxMJbG9jYWxob3N0MB4XDTEwMDgyMDIyMzIwOFoXDTM5MTIzMTIzNTk1OVowFDESMBAGA1UEAxMJbG9jYWxob3N0MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDPkfCSLRX8/4F+Z4ys43yZ4MMzjB44cMakPz4Nri+mEB5n2z/0GFatCYzkI2f/nniWqVrBYjHkjsZy2EZioHu4wa99c1XEGJnFNDuNn6ESkfEyhyF4+OqKGnpK9HNrw7OWMuqn2oOh0iFd9fl6FTAm+Y0p3LP+38BuYzpCniqqdwIDAQABo0kwRzBFBgNVHQEEPjA8gBDvi8Rgio9v+mr58TiAvqF5oRYwFDESMBAGA1UEAxMJbG9jYWxob3N0ghAdEzTisaf2sEZxrqYZfYtCMAkGBSsOAwIdBQADgYEANdGlvHKeUptfNu9I0wgA5qjmVB+JDldOAkrfM0R+4IcVQ06y5K7P07uxQAV7+rhnDLgLyFJunUHgzbfjsjFy7vjwtoieXA5j0AYlm4AHR7dHt4HVgkIMYt8XOCqMw5jjFX91xJ89tC7mM9zYR48N9T5QSeMGo+f+JzybeLWxnNs=" />
-        </identity>
-      </endpoint>
-      <endpoint address="net.tcp://localhost:8733/OKB-3.3/QueryService"
-        binding="netTcpBinding" bindingConfiguration="NetTcpBinding_IQueryService"
-        contract="OKBQuery.IQueryService" name="NetTcpBinding_IQueryService">
-        <identity>
-          <certificate encodedValue="AwAAAAEAAAAUAAAAD/AlkYJw/OUhl6D/9w8mjJBh39kgAAAAAQAAAPIBAAAwggHuMIIBW6ADAgECAhAdEzTisaf2sEZxrqYZfYtCMAkGBSsOAwIdBQAwFDESMBAGA1UEAxMJbG9jYWxob3N0MB4XDTEwMDgyMDIyMzIwOFoXDTM5MTIzMTIzNTk1OVowFDESMBAGA1UEAxMJbG9jYWxob3N0MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDPkfCSLRX8/4F+Z4ys43yZ4MMzjB44cMakPz4Nri+mEB5n2z/0GFatCYzkI2f/nniWqVrBYjHkjsZy2EZioHu4wa99c1XEGJnFNDuNn6ESkfEyhyF4+OqKGnpK9HNrw7OWMuqn2oOh0iFd9fl6FTAm+Y0p3LP+38BuYzpCniqqdwIDAQABo0kwRzBFBgNVHQEEPjA8gBDvi8Rgio9v+mr58TiAvqF5oRYwFDESMBAGA1UEAxMJbG9jYWxob3N0ghAdEzTisaf2sEZxrqYZfYtCMAkGBSsOAwIdBQADgYEANdGlvHKeUptfNu9I0wgA5qjmVB+JDldOAkrfM0R+4IcVQ06y5K7P07uxQAV7+rhnDLgLyFJunUHgzbfjsjFy7vjwtoieXA5j0AYlm4AHR7dHt4HVgkIMYt8XOCqMw5jjFX91xJ89tC7mM9zYR48N9T5QSeMGo+f+JzybeLWxnNs=" />
-        </identity>
-      </endpoint>
-    </client>
-  </system.serviceModel>
-</configuration>
Index: branches/OKB (trunk integration)/okbconfig.txt
===================================================================
--- branches/OKB (trunk integration)/okbconfig.txt	(revision 5296)
+++ 	(revision )
@@ -1,20 +1,0 @@
-windows
-  create new local user: okbserver
-
-sql server management studio
-  add sql server security/login: okbserver
-  add permissions on OKB database (select, insert, update, execute)
-
-IIS Manager
-  (add new website)
-    add site binding net.tcp 8001:*
-  add new application pool OKBApplicationPool
-    advanced settings->identity = okbserver
-    advanced settings->Load User Profile = true
-  add new web application OKB
-    basic settings->application pool = OKBApplicationPool
-    advanced settings->enabled protocols = net.tcp
-    
-Firewall configuration
-  allow connections to port 8001
-